// scancrdsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "scancrds.h"
#include "scancrdsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScancrdsDlg dialog

CScancrdsDlg::CScancrdsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScancrdsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScancrdsDlg)
	m_scrd1 = _T("");
	m_scrd2 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScancrdsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScancrdsDlg)
	DDX_Text(pDX, IDC_SCRD1, m_scrd1);
	DDX_Text(pDX, IDC_SCRD2, m_scrd2);
	DDX_Control(pDX, IDC_MSFLEXGRID1, m_grid1);
	DDX_Control(pDX, IDC_MSFLEXGRID2, m_grid2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CScancrdsDlg, CDialog)
	//{{AFX_MSG_MAP(CScancrdsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTNQUIT, OnButnquit)
	ON_BN_CLICKED(IDC_BUTNEXE, OnButnexe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScancrdsDlg message handlers

BOOL CScancrdsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CString str;
	int     i;

	dev_cnt = 0;
	CoInitialize(NULL);

	// Initial M3500A Object 
	Usb=new IIOUtils;
	Usb->CreateDispatch("Ins001.IOUtils");
	Usb->Refresh();

	// Get the connected M3500A device count
	dev_cnt=Usb->GetCount();     

	scard[0] = 0;
	scard[1] = 0;
	///////////////////////////////////////
	// Set the GUI 
	///////////////////////////////////////
	if(dev_cnt > 0)
	{
		GetDlgItem(IDC_SCRD1)->EnableWindow(TRUE);
		GetDlgItem(IDC_SCRD2)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTNEXE)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTNQUIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MSFLEXGRID1)->EnableWindow(FALSE);
		GetDlgItem(IDC_MSFLEXGRID2)->EnableWindow(FALSE);
		for (i=0; i<dev_cnt; i++)
		{
			// Set all the M3500A on the initial status
			Usb->SetIndex(i);
			str = "*RST";
			Usb->SetOutput(str);
			str = "*CLS";
			Usb->SetOutput(str);

			// Check the Scanner card configure for M3500A each
			str = Usb->Query("Rout:state?\n");
			if (str.Left(1) == "1")
			{
				scard[i] = 1;
				if ( i == 0 )
				{
					GetDlgItem(IDC_MSFLEXGRID1)->EnableWindow(TRUE);
				}
				else
				{
					GetDlgItem(IDC_MSFLEXGRID2)->EnableWindow(TRUE);
				}
			}
		}
		UpdateData(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SCRD1)->EnableWindow(FALSE);
		GetDlgItem(IDC_SCRD2)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTNEXE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTNQUIT)->EnableWindow(TRUE);
		UpdateData(FALSE);
		MessageBox("Multimeter device(s) not found.", "Scan card reading", MB_OK);
	}	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CScancrdsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CScancrdsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CScancrdsDlg::OnButnquit() 
{
	// TODO: Add your control notification handler code here

	// Check all connected M3500A and release M3500A object 
	if ( scard[0] )
	{
		Usb->SetIndex(0);
		Usb->Close();
	}
	if ( scard[1] )
	{
		Usb->SetIndex(1);
		Usb->Close();
	}
	delete Usb;

	OnOK();
}

void CScancrdsDlg::OnButnexe() 
{
	// TODO: Add your control notification handler code here
	
	CString str,str1;
	int     i, j, m;
	int		pos, row;
	BOOL    fDone = FALSE; 
	MSG     msg;

	for (i=0; i<dev_cnt; i++)
	{
		if ( scard[i] )
		{
			// Set the M3500A reading configure and reading count 
			Usb->SetIndex(i);
			str = "CONF:FRES 100000";
			Usb->SetOutput(str);
			str = "Rout:scan:count 20";
			Usb->SetOutput(str);
			str = "Rout:scan:timer 0.5";
			Usb->SetOutput(str);

			// Set the Scanner card the channels scan function
			for (j=1; j<=5; j++)
			{
				str.Format("%s%d,\"%s\"", "rout:scan:func ", j, "FRES");
				Usb->SetOutput(str);
			}
			str = "route:scan";
			Usb->SetOutput(str);
		}
	}

	if ( scard[0] )
		i = 1;
	else
		i = 0;
	if ( scard[1] )
		j = 1;
	else
		j = 0;

    while ( i | j )
	{
		while(true)
		{
			if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
			{
				if(msg.message != WM_QUIT)
				{
					TranslateMessage(&msg); 
					DispatchMessage(&msg); 
				}
			}
			else
				break;
		}

		// Check the scan reading state for M3500A device-0
		// and show the scanned count
		if ( i == 1 )
		{
			Usb->SetIndex(0);
			str = Usb->Query("Rout:scan:state?\n");
			m = int(atof(str));
			str.Format("%d / %s", m, "20");
			m_scrd1 = str;
			UpdateData(FALSE);
			if( m >= 20)
				i = 0;
		}

		// Check the scan reading state for M3500A device-1
		// and show the scanned count
		if ( j == 1 )
		{
			Usb->SetIndex(1);
			str = Usb->Query("Rout:scan:state?\n");
			m = int(atof(str));
			str.Format("%d / %s", m, "20");
			m_scrd2 = str;
			UpdateData(FALSE);
			if( m >= 20)
				j= 0;
		}
		Sleep(500);
	}

	if ( scard[0] )
	{
		pos = 1;
		row = 1;
		m_grid1.SetRow(0);
		m_grid1.SetColWidth(0,600);

		// Show the Channels title on the Grid
		for(int i = 0 ; i < 5 ; i ++)
		{
			m_grid1.SetCol(i+1);
			m_grid1.SetColWidth(i+1,1500);
			str.Format("CH%d(%s)", i+1, "4WR");
			m_grid1.SetCellAlignment(4);
			m_grid1.SetText(str);
		}

		// Fetch the scanned readings
		Usb->SetIndex(0);
		str = Usb->Query("fetch?\n");
		str1.Format("%s,",str);
	
		// Show the readings on the Grid
		while(pos > 0)
		{
			m_grid1.SetRow(row);
			m_grid1.SetCol(0);
			str.Format("%d",row);
			m_grid1.SetText(str);
			for(i = 0 ; i < 5; i ++)
			{	
				pos = str1.Find(",",0);
				if(pos < 1) 
					break;
				if(str1.Left(pos) == "+9.90000000E+37" || str1.Left(pos) == "+9.9E37\n")
					str = "OVLD";
				else
					str.Format("%.6f",atof(str1.Left(pos)));
				m_grid1.SetCol(i+1);
				m_grid1.SetText(str);
				str1 = str1.Mid(pos+1);
			}
			pos = str1.Find(",",0);
			row++;
		}
		UpdateData(FALSE);
	}

	if ( scard[1] )
	{
		pos = 1;
		row = 1;
		m_grid2.SetRow(0);
		m_grid2.SetColWidth(0,600);

		// Show the Channels title on the Grid
		for(int i = 0 ; i < 5 ; i ++)
		{
			m_grid2.SetCol(i+1);
			m_grid2.SetColWidth(i+1,1500);
			str.Format("CH%d (%s)", i+1, "4WR");
			m_grid2.SetCellAlignment(4);
			m_grid2.SetText(str);
		}

		// Fetch the scanned readings
		Usb->SetIndex(1);
		str = Usb->Query("fetch?\n");
		str1.Format("%s,",str);

		// Show the readings on the Grid		
		while(pos > 0)
		{
			m_grid2.SetRow(row);
			m_grid2.SetCol(0);
			str.Format("%d",row);
			m_grid2.SetText(str);
			for(i = 0 ; i < 5; i ++)
			{	
				pos = str1.Find(",",0);
				if(pos < 1) 
					break;
				if(str1.Left(pos) == "+9.90000000E+37" || str1.Left(pos) == "+9.9E37\n")
					str = "OVLD";
				else
					str.Format("%.6f",atof(str1.Left(pos)));
				m_grid2.SetCol(i+1);
				m_grid2.SetText(str);
				str1 = str1.Mid(pos+1);
			}
			pos = str1.Find(",",0);
			row++;
		}
		UpdateData(FALSE);
	}

}
